package vpc.util;

public class IntStack
{
    private int[] data;
    private int pos; // The index of the top-most element.  Starts out at -1;

    public IntStack(int initialSize)
    {
        if (initialSize < 0) throw new IllegalArgumentException("'initialSize' must not be negative (" + initialSize + ")");
        this.data = new int[initialSize];
        this.pos = -1;
    }

    public IntStack()
    {
        this(16);
    }

    public void push(int value)
    {
        int nextPos = pos+1;
        if (nextPos >= data.length) {
            int newSize = Math.max(4, data.length * 2);
            int[] newData = new int[newSize];
            System.arraycopy(data, 0, newData, 0, data.length);
            data = newData;
        }
        data[nextPos] = value;
        pos = nextPos;
    }

    public int pop() throws java.util.EmptyStackException
    {
        if (pos < 0) throw new java.util.EmptyStackException();
        return data[pos--];
    }

    public int peek() throws java.util.EmptyStackException
    {
        if (pos < 0) throw new java.util.EmptyStackException();
        return data[pos];
    }

    public boolean isEmpty()
    {
        return (pos < 0);
    }
}
